#!/bin/sh
#------------------------------------------------------------------------------
# dyndns.cgi - display the answers from the dyndns services
# part of opt_dyndns 2.1.17a, see documentation for licence
#
# (c) copyright 2001-2002 Thomas Mueller
# (c) copyright 2002-2003 Tobias Gruetzmacher
#
# Creation:    27.08.2001 Thomas Mueller
# Last update: $Id: main_DynDNS.cgi,v 1.1.1.1.2.1 2004/08/09 22:20:06 tobias Exp $
#------------------------------------------------------------------------------

logdir="/var/log/dyndns"

cat << MUCHTEXT
Content-Type: text/html; charset=iso-8859-1
Cache-control: no-store
Pragma: no-cache
Expires: `date -Ru`

<html><head>
<LINK REL=STYLESHEET TYPE="text/css" HREF="main.css">
<title>Answers from DynDNS services</title>
</head><body>

<table border="0" width="95%" cellspacing="0" cellpadding="0" align="center"><tr>
<th align="left" bgcolor="#C0C0C0"><b>Answers from DynDNS services</b></th>
</tr>

<tr><td>
This table shows the answers the router got from
the services configured in OPT_DYNDNS.
</td></tr>

<tr><td>
<table width="100%" border="1" cellpadding="5">
<tr><th align="left">hostname</th><th align="left">answer</th></tr>
MUCHTEXT

for fn in $logdir/*
do
  if [ -f "$fn" ]
  then
    echo '<tr><td valign="top" align="left" rowspan="2">'
    sed '
    1 {
      b
    }
    2 {
      s/^/<\/td><td>/
      s/$/<\/td><\/tr><tr><td><pre>/
      b
    }
    $ d
    # save error codes from ZoneEdit from being removed as html tags
    s/<ERROR /ERROR /g
    s/<SUCCESS /SUCCESS /g
    # remove html comments
    /<!--/ !bb
    :a
    /-->/ !{
      N
      ba
    }
    s/<!--.*-->//
    # remove most html tags
    :b
    s/<[^<]*>/ /g
    /</ {
      N
      s/\n/ /
      bb
    }' $fn
    echo '</pre></td></tr>'
  fi
done

echo "</table></td></tr></table></body></html>"
# vi: set tabstop=2 shiftwidth=2 expandtab:
